/*
	This file is distributed under the terms of the GNU Public License, version 2.
	
	Copyright (c) Stijn Buys, 2009
*/

#ifndef __INCLUDED_GLOCK_CLOCK__
#define __INCLUDED_GLOCK_CLOCK__

#include "context.h"

namespace glock {

class Clock {

public:
	Clock(const Context* context);
	
	virtual ~Clock();

	inline const Context* context() const { return clock_context; }
	
	inline const unsigned int hours() const { return clock_hours; }
	
	inline const unsigned int minutes() const { return clock_minutes; }
	
	inline const unsigned int seconds() const { return clock_seconds; }
	
	void get_time();
	
	virtual void draw() = 0;
	
private:
	const Context* 	clock_context;
	
	unsigned int 	clock_hours;
	unsigned int 	clock_minutes;
	unsigned int 	clock_seconds;
};

} // namespace glock

#endif // __INCLUDED_GLOCK_CLOCK__
