/*
	This file is distributed under the terms of the GNU Public License, version 2.
	
	Copyright (c) Stijn Buys, 2009
*/

#ifndef __INCLUDED_GLOCK_CLOCKFLAT__
#define __INCLUDED_GLOCK_CLOCKFLAT__

#include "clock.h"

namespace glock {

class ClockFlat : public Clock {
public:
	ClockFlat(const Context* context);
	virtual ~ClockFlat();
	
	void draw();

private:
	void draw_tick(float angle, float width, float from_radius, float to_radius);
	
	void draw_disc(float width);
	
	void draw_hand(float angle, float width, float length, bool disc);
	
	float sin_table[60];
	float cos_table[60];
};

} // namespace glock

#endif // __INCLUDED_GLOCK_CLOCKFLAT__

