/*
	This file is distributed under the terms of the GNU Public License, version 2.
	
	Copyright (c) Stijn Buys, 2009
*/

#ifndef __INCLUDED_GLOCK_CONTEXT__
#define __INCLUDED_GLOCK_CONTEXT__

#include <windows.h>

namespace glock {

class Context {

public:
	/// initialize wgl context
	Context(HWND handle);
	
	/// shutdow wgl context
	~Context();
	
	/// current screen width, in pixels
	inline const int width() const { return context_width; }
	
	/// current screen height, in pixels
	inline const int height() const { return context_height; }
	
	/// swap buffers
	void swap_buffers();
	
	/// reset the OpenGL context
	void reset();
	
private:

	int 		context_width;
	int 		context_height;
	
	HWND		context_handle;
	HDC 		context_device;
	HGLRC 		context_wgl;
};

} // namespace glock

#endif // __INCLUDED_GLOCK_CONTEXT__

