/*
	glock is a simple OpenGL clock screensaver for windows,
	inspired by the KClock screensaver found in the KDE Desktop Environment.

	Copyright (c) Stijn Buys, 2009
	
	This file is distributed under the terms of the GNU Public License, version 2.
*/

#include <windows.h>
#include <scrnsave.h>

#include "context.h"
#include "clockflat.h"

static glock::Context *glcontext = 0;
static glock::Clock *glclock = 0;
const UINT_PTR timer_id = 1;

// screen saver message handler
LRESULT WINAPI ScreenSaverProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	
		case WM_CREATE:
			if (!glcontext) {
				glcontext = new glock::Context(hWnd);
				glclock = new glock::ClockFlat(glcontext);
	
				SetTimer(hWnd, timer_id, 100, NULL);
			}
			return 0;
			
		case WM_DESTROY:
			if (glcontext) {
				KillTimer(hWnd, timer_id);
	
				delete glclock;
				glclock = 0;
			
				delete glcontext;
				glcontext = 0;	
			}
			return 0;
			
		case WM_TIMER:
			// draw the clock
			glclock->get_time();
			glclock->draw();
			
			// swap buffers
			glcontext->swap_buffers();
			return 0;
	}
	
	return DefScreenSaverProc(hWnd, message, wParam, lParam);
}

BOOL WINAPI ScreenSaverConfigureDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return FALSE;
}

// needed for SCRNSAVE.LIB
BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
	return TRUE;
}
